interface Feature {
}

interface IPhoneFeature extends Feature {
    void execute(IPhone anIPhone);
}

interface CommunicatorFeature extends Feature {
    void execute(Communicator aCommunicator);
}

interface CISCOFeature extends Feature {
    /// void execute(CisaCommunicator);
}

class TakePictureFeature implements CommunicatorFeature{

    public void execute(IPhone anIPhone) {
        System.out.println("iPhone Picture " + anIPhone.myLogo);
    }

    public void execute(Communicator aCommunicator) {
        System.out.println("Communicator Picture " + aCommunicator.myNumber);
    }
}

interface SmartPhone {
  void makeCall();
  void manageCalendar();

  void runFancyFeature(Feature aFeature);
}

class IPhone implements SmartPhone {
    String myLogo;
    public IPhone(String myLogo) {this.myLogo = myLogo; }
    public void makeCall() {
        System.out.println("*** " + myLogo + " *** iPhone makes a call");
    }

    public void manageCalendar() {
        System.out.println("*** " + myLogo + " *** iPhone manages calendar");
    }

    public void runFancyFeature(Feature aFeature) {
        if(aFeature instanceof IPhoneFeature)
            ((IPhoneFeature)aFeature).execute(this);  // execute aici face ceva specific pentru iPhone
    }


}

class Communicator implements SmartPhone {
    long myNumber;
    public Communicator(long myNumber) {this.myNumber = myNumber; }

    public void makeCall() {
        System.out.println("@@@ " + myNumber + " @@@ Communicator makes a call");
    }

    public void manageCalendar() {
        System.out.println("@@@ " + myNumber + " @@@ Communicator manages calendar");
    }

    public void runFancyFeature(Feature aFeature) {
        if(aFeature instanceof CommunicatorFeature)
            ((CommunicatorFeature)aFeature).execute(this);  // execute aici face ceva specific pentru Communicator
    }
}

class MainPhones {
    public static void main(String[] args) {
        new Communicator(234432).manageCalendar();

        SmartPhone anIPhone = new IPhone("blabla");
        Feature feature = new TakePictureFeature();

        anIPhone.runFancyFeature(feature);
    }
}